diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-phy-reception-test.cc ns-3.39/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.38/src/wifi/test/wifi-phy-reception-test.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wifi/test/wifi-phy-reception-test.cc	2023-07-05 14:23:48.133428300 -0700
@@ -1374,11 +1391,15 @@
     Simulator::Schedule(Seconds(10.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(10.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 3);
+                        rxPowerDbm + 3,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected, hence STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(10.0) + NanoSeconds(3999),
@@ -1415,11 +1436,15 @@
     Simulator::Schedule(Seconds(11.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(11.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 6);
+                        rxPowerDbm + 6,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(11.0) + NanoSeconds(3999),
@@ -1466,7 +1491,9 @@
     Simulator::Schedule(Seconds(12.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(12.0) + NanoSeconds(3999),
@@ -1512,11 +1539,15 @@
     Simulator::Schedule(Seconds(13.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(13.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(13.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState,
@@ -1540,11 +1571,15 @@
     Simulator::Schedule(Seconds(14.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(14.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(14.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState,
@@ -1566,11 +1601,15 @@
     Simulator::Schedule(Seconds(15.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(15.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 6);
+                        rxPowerDbm - 6,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(15.0) + NanoSeconds(3999),
@@ -1618,11 +1657,15 @@
     Simulator::Schedule(Seconds(16.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(16.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 3);
+                        rxPowerDbm + 3,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(16.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState,
@@ -1650,11 +1693,15 @@
     Simulator::Schedule(Seconds(17.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(17.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 6);
+                        rxPowerDbm + 6,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(17.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState,
@@ -1703,11 +1750,15 @@
     Simulator::Schedule(Seconds(18.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(18.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 50);
+                        rxPowerDbm + 50,
+                        1000,
+                        7);
     // The second packet should be received successfully
     Simulator::Schedule(Seconds(18.1),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckRxPacketCount,
@@ -1720,11 +1771,15 @@
     Simulator::Schedule(Seconds(19.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(19.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 10);
+                        rxPowerDbm + 10,
+                        1000,
+                        7);
     // The second packet should be captured, but not decoded since SNR to low for used MCS
     Simulator::Schedule(Seconds(19.1),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckRxPacketCount,
@@ -1737,11 +1792,15 @@
     Simulator::Schedule(Seconds(20.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(20.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 50);
+                        rxPowerDbm + 50,
+                        1000,
+                        7);
     // The second packet should be received successfully, same as in CASE 13
     Simulator::Schedule(Seconds(20.1),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckRxPacketCount,
@@ -1754,11 +1813,15 @@
     Simulator::Schedule(Seconds(21.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(21.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 10);
+                        rxPowerDbm + 10,
+                        1000,
+                        7);
     // The second packet should be captured, but not decoded since SNR to low for used MCS, same as
     // in CASE 19
     Simulator::Schedule(Seconds(21.1),
@@ -1777,17 +1840,13 @@
  *
  * \brief Simple frame capture model test
  */
-class TestSimpleFrameCaptureModel : public TestCase
+class TestSimpleFrameCaptureModel : public WifiPhyReceptionTest
 {
   public:
     TestSimpleFrameCaptureModel();
-    ~TestSimpleFrameCaptureModel() override;
-
-  protected:
-    void DoSetup() override;
-    void DoTeardown() override;
 
   private:
+    void DoSetup() override;
     void DoRun() override;
 
     /**
@@ -1795,12 +1854,6 @@
      */
     void Reset();
     /**
-     * Send packet function
-     * \param rxPowerDbm the transmit power in dBm
-     * \param packetSize the size of the packet in bytes
-     */
-    void SendPacket(double rxPowerDbm, uint32_t packetSize);
-    /**
      * Spectrum wifi receive success function
      * \param psdu the PSDU
      * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
@@ -1835,60 +1888,18 @@
      */
     void Expect1500BPacketDropped();
 
-    Ptr<SpectrumWifiPhy> m_phy; ///< Phy
-
-    bool m_rxSuccess1000B; ///< count received packets with 1000B payload
-    bool m_rxSuccess1500B; ///< count received packets with 1500B payload
-    bool m_rxDropped1000B; ///< count dropped packets with 1000B payload
-    bool m_rxDropped1500B; ///< count dropped packets with 1500B payload
-
-    uint64_t m_uid; //!< the UID to use for the PPDU
+    bool m_rxSuccess1000B{false}; ///< count received packets with 1000B payload
+    bool m_rxSuccess1500B{false}; ///< count received packets with 1500B payload
+    bool m_rxDropped1000B{false}; ///< count dropped packets with 1000B payload
+    bool m_rxDropped1500B{false}; ///< count dropped packets with 1500B payload
 };
 
 TestSimpleFrameCaptureModel::TestSimpleFrameCaptureModel()
-    : TestCase("Simple frame capture model test"),
-      m_rxSuccess1000B(false),
-      m_rxSuccess1500B(false),
-      m_rxDropped1000B(false),
-      m_rxDropped1500B(false),
-      m_uid(0)
+    : WifiPhyReceptionTest("Simple frame capture model test")
 {
 }
 
 void
-TestSimpleFrameCaptureModel::SendPacket(double rxPowerDbm, uint32_t packetSize)
-{
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
-
-    Ptr<Packet> pkt = Create<Packet>(packetSize);
-    WifiMacHeader hdr;
-
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
-
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
-    Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
-
-    Ptr<WifiPpdu> ppdu =
-        Create<HePpdu>(psdu, txVector, FREQUENCY, txDuration, WIFI_PHY_BAND_5GHZ, m_uid++);
-
-    Ptr<SpectrumValue> txPowerSpectrum =
-        WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
-                                                                    CHANNEL_WIDTH,
-                                                                    DbmToW(rxPowerDbm),
-                                                                    GUARD_WIDTH);
-
-    Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
-    txParams->psd = txPowerSpectrum;
-    txParams->txPhy = nullptr;
-    txParams->duration = txDuration;
-    txParams->ppdu = ppdu;
-
-    m_phy->StartRx(txParams);
-}
-
-void
 TestSimpleFrameCaptureModel::RxSuccess(Ptr<const WifiPsdu> psdu,
                                        RxSignalInfo rxSignalInfo,
                                        WifiTxVector txVector,
@@ -1953,21 +1964,10 @@
     NS_TEST_ASSERT_MSG_EQ(m_rxDropped1500B, true, "Didn't drop 1500B packet");
 }
 
-TestSimpleFrameCaptureModel::~TestSimpleFrameCaptureModel()
-{
-    m_phy = nullptr;
-}
-
 void
 TestSimpleFrameCaptureModel::DoSetup()
 {
-    m_phy = CreateObject<SpectrumWifiPhy>();
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
-    m_phy->SetErrorRateModel(error);
-    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
+    WifiPhyReceptionTest::DoSetup();
 
     m_phy->SetReceiveOkCallback(MakeCallback(&TestSimpleFrameCaptureModel::RxSuccess, this));
     m_phy->TraceConnectWithoutContext("PhyRxDrop",
@@ -1985,13 +1985,6 @@
 }
 
 void
-TestSimpleFrameCaptureModel::DoTeardown()
-{
-    m_phy->Dispose();
-    m_phy = nullptr;
-}
-
-void
 TestSimpleFrameCaptureModel::DoRun()
 {
     RngSeedManager::SetSeed(1);
@@ -2007,12 +2000,14 @@
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm,
-                        1000);
+                        1000,
+                        0);
     Simulator::Schedule(Seconds(1.0) + MicroSeconds(10.0),
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm,
-                        1500);
+                        1500,
+                        0);
     Simulator::Schedule(Seconds(1.1), &TestSimpleFrameCaptureModel::Expect1500BPacketDropped, this);
     Simulator::Schedule(Seconds(1.2), &TestSimpleFrameCaptureModel::Reset, this);
 
@@ -2023,12 +2018,14 @@
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm,
-                        1000);
+                        1000,
+                        0);
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(10.0),
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm - 6,
-                        1500);
+                        1500,
+                        0);
     Simulator::Schedule(Seconds(2.1),
                         &TestSimpleFrameCaptureModel::Expect1000BPacketReceived,
                         this);
@@ -2042,12 +2039,14 @@
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm,
-                        1000);
+                        1000,
+                        0);
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(10.0),
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm + 6,
-                        1500);
+                        1500,
+                        0);
     Simulator::Schedule(Seconds(3.1), &TestSimpleFrameCaptureModel::Expect1000BPacketDropped, this);
     Simulator::Schedule(Seconds(3.1),
                         &TestSimpleFrameCaptureModel::Expect1500BPacketReceived,
@@ -2062,12 +2061,14 @@
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm,
-                        1000);
+                        1000,
+                        0);
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(25.0),
                         &TestSimpleFrameCaptureModel::SendPacket,
                         this,
                         rxPowerDbm + 6,
-                        1500);
+                        1500,
+                        0);
     Simulator::Schedule(Seconds(4.1), &TestSimpleFrameCaptureModel::Expect1500BPacketDropped, this);
     Simulator::Schedule(Seconds(4.2), &TestSimpleFrameCaptureModel::Reset, this);
 
@@ -2081,123 +2082,18 @@
  *
  * \brief Test PHY state upon success or failure of L-SIG and SIG-A
  */
-class TestPhyHeadersReception : public TestCase
+class TestPhyHeadersReception : public WifiPhyReceptionTest
 {
   public:
     TestPhyHeadersReception();
-    ~TestPhyHeadersReception() override;
-
-  protected:
-    void DoSetup() override;
-    void DoTeardown() override;
-    Ptr<SpectrumWifiPhy> m_phy; ///< Phy
-    /**
-     * Send packet function
-     * \param rxPowerDbm the transmit power in dBm
-     */
-    void SendPacket(double rxPowerDbm);
 
   private:
     void DoRun() override;
-
-    /**
-     * Schedule now to check  the PHY state
-     * \param expectedState the expected PHY state
-     */
-    void CheckPhyState(WifiPhyState expectedState);
-    /**
-     * Check the PHY state now
-     * \param expectedState the expected PHY state
-     */
-    void DoCheckPhyState(WifiPhyState expectedState);
-
-    uint64_t m_uid; //!< the UID to use for the PPDU
 };
 
 TestPhyHeadersReception::TestPhyHeadersReception()
-    : TestCase("PHY headers reception test"),
-      m_uid(0)
-{
-}
-
-void
-TestPhyHeadersReception::SendPacket(double rxPowerDbm)
-{
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs7(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
-
-    Ptr<Packet> pkt = Create<Packet>(1000);
-    WifiMacHeader hdr;
-
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
-
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
-    Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
-
-    Ptr<WifiPpdu> ppdu =
-        Create<HePpdu>(psdu, txVector, FREQUENCY, txDuration, WIFI_PHY_BAND_5GHZ, m_uid++);
-
-    Ptr<SpectrumValue> txPowerSpectrum =
-        WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
-                                                                    CHANNEL_WIDTH,
-                                                                    DbmToW(rxPowerDbm),
-                                                                    GUARD_WIDTH);
-
-    Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
-    txParams->psd = txPowerSpectrum;
-    txParams->txPhy = nullptr;
-    txParams->duration = txDuration;
-    txParams->ppdu = ppdu;
-
-    m_phy->StartRx(txParams);
-}
-
-void
-TestPhyHeadersReception::CheckPhyState(WifiPhyState expectedState)
+    : WifiPhyReceptionTest("PHY headers reception test")
 {
-    // This is needed to make sure PHY state will be checked as the last event if a state change
-    // occurred at the exact same time as the check
-    Simulator::ScheduleNow(&TestPhyHeadersReception::DoCheckPhyState, this, expectedState);
-}
-
-void
-TestPhyHeadersReception::DoCheckPhyState(WifiPhyState expectedState)
-{
-    WifiPhyState currentState;
-    PointerValue ptr;
-    m_phy->GetAttribute("State", ptr);
-    Ptr<WifiPhyStateHelper> state = DynamicCast<WifiPhyStateHelper>(ptr.Get<WifiPhyStateHelper>());
-    currentState = state->GetState();
-    NS_LOG_FUNCTION(this << currentState);
-    NS_TEST_ASSERT_MSG_EQ(currentState,
-                          expectedState,
-                          "PHY State " << currentState << " does not match expected state "
-                                       << expectedState << " at " << Simulator::Now());
-}
-
-TestPhyHeadersReception::~TestPhyHeadersReception()
-{
-    m_phy = nullptr;
-}
-
-void
-TestPhyHeadersReception::DoSetup()
-{
-    m_phy = CreateObject<SpectrumWifiPhy>();
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
-    m_phy->SetErrorRateModel(error);
-    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
-}
-
-void
-TestPhyHeadersReception::DoTeardown()
-{
-    m_phy->Dispose();
-    m_phy = nullptr;
 }
 
 void
@@ -2215,11 +2111,18 @@
     // preamble detection window and the start of L-SIG of the first packet: reception should be
     // aborted since L-SIG cannot be decoded (SNR too low).
 
-    Simulator::Schedule(Seconds(1.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(1.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(1.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(1.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2246,11 +2149,18 @@
     // preamble detection window and the start of L-SIG of the first packet: reception should not be
     // aborted since L-SIG can be decoded (SNR high enough).
 
-    Simulator::Schedule(Seconds(2.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(2.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2290,11 +2200,18 @@
     // the start of HE-SIG of the first packet: PHY header reception should not succeed but PHY
     // should stay in RX state for the duration estimated from L-SIG.
 
-    Simulator::Schedule(Seconds(3.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(3.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 44us (end of PHY header), STA PHY STATE should not have moved to RX (HE-SIG failed) and be
     // kept to CCA_BUSY.
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(44.0),
@@ -2324,11 +2241,18 @@
     // CASE 4: send one packet followed by a second one 3 dB weaker between the end of L-SIG and the
     // start of HE-SIG of the first packet: PHY header reception should succeed.
 
-    Simulator::Schedule(Seconds(4.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(4.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2371,11 +2295,18 @@
     // preamble detection window and the start of L-SIG of the first packet: reception should be
     // aborted since L-SIG cannot be decoded (SNR too low).
 
-    Simulator::Schedule(Seconds(5.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(5.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2392,11 +2323,18 @@
     // preamble detection window and the start of L-SIG of the first packet: reception should not be
     // aborted since L-SIG can be decoded (SNR high enough).
 
-    Simulator::Schedule(Seconds(6.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(6.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(6.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(6.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2433,11 +2371,18 @@
     // the start of HE-SIG of the first packet: PHY header reception should not succeed but PHY
     // should stay in RX state for the duration estimated from L-SIG.
 
-    Simulator::Schedule(Seconds(7.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(7.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(7.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(7.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2465,11 +2410,18 @@
     // CASE 8: send one packet followed by a second one 3 dB weaker between the end of L-SIG and the
     // start of HE-SIG of the first packet: PHY header reception should succeed.
 
-    Simulator::Schedule(Seconds(8.0), &TestPhyHeadersReception::SendPacket, this, rxPowerDbm);
+    Simulator::Schedule(Seconds(8.0),
+                        &TestPhyHeadersReception::SendPacket,
+                        this,
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(8.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
     Simulator::Schedule(Seconds(8.0) + MicroSeconds(10.0),
                         &TestPhyHeadersReception::CheckPhyState,
@@ -2512,17 +2464,13 @@
  *
  * \brief A-MPDU reception test
  */
-class TestAmpduReception : public TestCase
+class TestAmpduReception : public WifiPhyReceptionTest
 {
   public:
     TestAmpduReception();
-    ~TestAmpduReception() override;
-
-  protected:
-    void DoSetup() override;
-    void DoTeardown() override;
 
   private:
+    void DoSetup() override;
     void DoRun() override;
 
     /**
@@ -2609,35 +2557,19 @@
      */
     void CheckPhyState(WifiPhyState expectedState);
 
-    Ptr<SpectrumWifiPhy> m_phy; ///< Phy
+    uint8_t m_rxSuccessBitmapAmpdu1{0}; ///< bitmap of successfully received MPDUs in A-MPDU #1
+    uint8_t m_rxSuccessBitmapAmpdu2{0}; ///< bitmap of successfully received MPDUs in A-MPDU #2
 
-    uint8_t m_rxSuccessBitmapAmpdu1; ///< bitmap of successfully received MPDUs in A-MPDU #1
-    uint8_t m_rxSuccessBitmapAmpdu2; ///< bitmap of successfully received MPDUs in A-MPDU #2
+    uint8_t m_rxFailureBitmapAmpdu1{0}; ///< bitmap of unsuccessfully received MPDUs in A-MPDU #1
+    uint8_t m_rxFailureBitmapAmpdu2{0}; ///< bitmap of unsuccessfully received MPDUs in A-MPDU #2
 
-    uint8_t m_rxFailureBitmapAmpdu1; ///< bitmap of unsuccessfuly received MPDUs in A-MPDU #1
-    uint8_t m_rxFailureBitmapAmpdu2; ///< bitmap of unsuccessfuly received MPDUs in A-MPDU #2
-
-    uint8_t m_rxDroppedBitmapAmpdu1; ///< bitmap of dropped MPDUs in A-MPDU #1
-    uint8_t m_rxDroppedBitmapAmpdu2; ///< bitmap of dropped MPDUs in A-MPDU #2
-
-    uint64_t m_uid; ///< UID
+    uint8_t m_rxDroppedBitmapAmpdu1{0}; ///< bitmap of dropped MPDUs in A-MPDU #1
+    uint8_t m_rxDroppedBitmapAmpdu2{0}; ///< bitmap of dropped MPDUs in A-MPDU #2
 };
 
 TestAmpduReception::TestAmpduReception()
-    : TestCase("A-MPDU reception test"),
-      m_rxSuccessBitmapAmpdu1(0),
-      m_rxSuccessBitmapAmpdu2(0),
-      m_rxFailureBitmapAmpdu1(0),
-      m_rxFailureBitmapAmpdu2(0),
-      m_rxDroppedBitmapAmpdu1(0),
-      m_rxDroppedBitmapAmpdu2(0),
-      m_uid(0)
-{
-}
-
-TestAmpduReception::~TestAmpduReception()
+    : WifiPhyReceptionTest("A-MPDU reception test")
 {
-    m_phy = nullptr;
 }
 
 void
@@ -2860,7 +2792,7 @@
     Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
 
     Ptr<WifiPpdu> ppdu =
-        Create<HePpdu>(psdu, txVector, FREQUENCY, txDuration, WIFI_PHY_BAND_5GHZ, m_uid++);
+        Create<HePpdu>(psdu, txVector, m_phy->GetOperatingChannel(), txDuration, m_uid++);
 
     Ptr<SpectrumValue> txPowerSpectrum =
         WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
